## libbpf 0.3

=== src/Makefile ===
# SPDX-License-Identifier: (LGPL-2.1 OR BSD-2-Clause)

ifeq ($(V),1)
	Q =
	msg =
else
	Q = @
	msg = @printf '  %-8s %s%s\n' "$(1)" "$(notdir $(2))" "$(if $(3), $(3))";
endif

LIBBPF_VERSION := $(shell \
	grep -oE '^LIBBPF_([0-9.]+)' libbpf.map | \
	sort -rV | head -n1 | cut -d'_' -f2)
LIBBPF_MAJOR_VERSION := $(firstword $(subst ., ,$(LIBBPF_VERSION)))

TOPDIR = ..

INCLUDES := -I. -I$(TOPDIR)/include -I$(TOPDIR)/include/uapi
ALL_CFLAGS := $(INCLUDES)

SHARED_CFLAGS += -fPIC -fvisibility=hidden -DSHARED

CFLAGS ?= -g -O2 -Werror -Wall
ALL_CFLAGS += $(CFLAGS) -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
ALL_LDFLAGS += $(LDFLAGS)
ifdef NO_PKG_CONFIG
	ALL_LDFLAGS += -lelf -lz
else
	PKG_CONFIG ?= pkg-config
	ALL_CFLAGS += $(shell $(PKG_CONFIG) --cflags libelf zlib)
	ALL_LDFLAGS += $(shell $(PKG_CONFIG) --libs libelf zlib)
endif

OBJDIR ?= .
SHARED_OBJDIR := $(OBJDIR)/sharedobjs
STATIC_OBJDIR := $(OBJDIR)/staticobjs
OBJS := bpf.o btf.o libbpf.o libbpf_errno.o netlink.o \
	nlattr.o str_error.o libbpf_probes.o bpf_prog_linfo.o xsk.o \
	btf_dump.o hashmap.o ringbuf.o
SHARED_OBJS := $(addprefix $(SHARED_OBJDIR)/,$(OBJS))
STATIC_OBJS := $(addprefix $(STATIC_OBJDIR)/,$(OBJS))

STATIC_LIBS := $(OBJDIR)/libbpf.a
ifndef BUILD_STATIC_ONLY
	SHARED_LIBS := $(OBJDIR)/libbpf.so \
		       $(OBJDIR)/libbpf.so.$(LIBBPF_MAJOR_VERSION) \
		       $(OBJDIR)/libbpf.so.$(LIBBPF_VERSION)
	VERSION_SCRIPT := libbpf.map
endif

HEADERS := bpf.h libbpf.h btf.h xsk.h libbpf_util.h \
	   bpf_helpers.h bpf_helper_defs.h bpf_tracing.h \
	   bpf_endian.h bpf_core_read.h libbpf_common.h
UAPI_HEADERS := $(addprefix $(TOPDIR)/include/uapi/linux/,\
			    bpf.h bpf_common.h btf.h)

PC_FILE := $(OBJDIR)/libbpf.pc

INSTALL = install

DESTDIR ?=

ifeq ($(shell uname -m),x86_64)
	LIBSUBDIR := lib64
else
	LIBSUBDIR := lib
endif

# By default let the pc file itself use ${prefix} in includedir/libdir so that
# the prefix can be overridden at runtime (eg: --define-prefix)
ifndef LIBDIR
	LIBDIR_PC := $$\{prefix\}/$(LIBSUBDIR)
else
	LIBDIR_PC := $(LIBDIR)
endif
PREFIX ?= /usr
LIBDIR ?= $(PREFIX)/$(LIBSUBDIR)
INCLUDEDIR ?= $(PREFIX)/include
UAPIDIR ?= $(PREFIX)/include

TAGS_PROG := $(if $(shell which etags 2>/dev/null),etags,ctags)

all: $(STATIC_LIBS) $(SHARED_LIBS) $(PC_FILE)

$(OBJDIR)/libbpf.a: $(STATIC_OBJS)
	$(call msg,AR,$@)
	$(Q)$(AR) rcs $@ $^

$(OBJDIR)/libbpf.so: $(OBJDIR)/libbpf.so.$(LIBBPF_MAJOR_VERSION)
	$(Q)ln -sf $(^F) $@

$(OBJDIR)/libbpf.so.$(LIBBPF_MAJOR_VERSION): $(OBJDIR)/libbpf.so.$(LIBBPF_VERSION)
	$(Q)ln -sf $(^F) $@

$(OBJDIR)/libbpf.so.$(LIBBPF_VERSION): $(SHARED_OBJS)
	$(call msg,CC,$@)
	$(Q)$(CC) -shared -Wl,--version-script=$(VERSION_SCRIPT) \
		  -Wl,-soname,libbpf.so.$(LIBBPF_MAJOR_VERSION) \
		  $^ $(ALL_LDFLAGS) -o $@

$(OBJDIR)/libbpf.pc:
	$(Q)sed -e "s|@PREFIX@|$(PREFIX)|" \
		-e "s|@LIBDIR@|$(LIBDIR_PC)|" \
		-e "s|@VERSION@|$(LIBBPF_VERSION)|" \
		< libbpf.pc.template > $@

$(STATIC_OBJDIR) $(SHARED_OBJDIR):
	$(call msg,MKDIR,$@)
	$(Q)mkdir -p $@

$(STATIC_OBJDIR)/%.o: %.c | $(STATIC_OBJDIR)
	$(call msg,CC,$@)
	$(Q)$(CC) $(ALL_CFLAGS) $(CPPFLAGS) -c $< -o $@

$(SHARED_OBJDIR)/%.o: %.c | $(SHARED_OBJDIR)
	$(call msg,CC,$@)
	$(Q)$(CC) $(ALL_CFLAGS) $(SHARED_CFLAGS) $(CPPFLAGS) -c $< -o $@

define do_install
	$(call msg,INSTALL,$1)
	$(Q)if [ ! -d '$(DESTDIR)$2' ]; then		\
		$(INSTALL) -d -m 755 '$(DESTDIR)$2';	\
	fi;
	$(Q)$(INSTALL) $1 $(if $3,-m $3,) '$(DESTDIR)$2'
endef

# Preserve symlinks at installation.
define do_s_install
	$(call msg,INSTALL,$1)
	$(Q)if [ ! -d '$(DESTDIR)$2' ]; then		\
		$(INSTALL) -d -m 755 '$(DESTDIR)$2';	\
	fi;
	$(Q)cp -fpR $1 '$(DESTDIR)$2'
endef

install: all install_headers install_pkgconfig
	$(call do_s_install,$(STATIC_LIBS) $(SHARED_LIBS),$(LIBDIR))

install_headers:
	$(call do_install,$(HEADERS),$(INCLUDEDIR)/bpf,644)

# UAPI headers can be installed by a different package so they're not installed
# in by install rule.
install_uapi_headers:
	$(call do_install,$(UAPI_HEADERS),$(UAPIDIR)/linux,644)

install_pkgconfig: $(PC_FILE)
	$(call do_install,$(PC_FILE),$(LIBDIR)/pkgconfig,644)

clean:
	$(call msg,CLEAN)
	$(Q)rm -rf *.o *.a *.so *.so.* *.pc $(SHARED_OBJDIR) $(STATIC_OBJDIR)

.PHONY: cscope tags
cscope:
	$(call msg,CSCOPE)
	$(Q)ls *.c *.h > cscope.files
	$(Q)cscope -b -q -f cscope.out

tags:
	$(call msg,CTAGS)
	$(Q)rm -f TAGS tags
	$(Q)ls *.c *.h | xargs $(TAGS_PROG) -a

## libbpf 0.1.0

=== debian/changelog ===
libbpf (0.1.0-1) unstable; urgency=medium

  * Update from upstream v0.1.0
    - Update symbols file.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 26 Aug 2020 22:40:21 +0100

libbpf (0.0.9-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Sudip Mukherjee ]
  * Update from upstream v0.0.9
    - Update symbols file.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 23 Jul 2020 18:35:16 +0100

libbpf (0.0.8-1) unstable; urgency=medium

  * Update from upstream v0.0.8
  * Update symbols file.
  * Update compat level to 13.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 01 May 2020 09:44:49 +0100

libbpf (0.0.6-1) unstable; urgency=medium

  * Package from github. (Closes: #948041)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 11 Apr 2020 16:12:37 +0100

=== debian/control ===
Source: libbpf
Priority: optional
Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
Build-Depends: debhelper-compat (= 13), libelf-dev
Standards-Version: 4.5.0
Section: libs
Vcs-Browser: https://github.com/sudipm-mukherjee/libbpf
Vcs-Git: https://github.com/sudipm-mukherjee/libbpf.git

Package: libbpf-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends}, libbpf0 (= ${binary:Version})
Description: eBPF helper library (development files)
 libbpf is a library for loading eBPF programs and reading and
 manipulating eBPF objects from user-space.
 .
 This package is needed to compile programs against libbpf.

Package: libbpf0
Architecture: linux-any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: eBPF helper library (shared library)
 libbpf is a library for loading eBPF programs and reading and
 manipulating eBPF objects from user-space.
 .
 This package contains the shared library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Werror=implicit-function-declaration
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk

%:
	dh $@ --sourcedirectory=src

override_dh_gencontrol:
	dh_gencontrol -- -v1:$(DEB_VERSION)

override_dh_makeshlibs:
	dh_makeshlibs -- -v1:$(DEB_VERSION)

override_dh_auto_build:
	dh_auto_build -- LIBSUBDIR=lib/$(DEB_HOST_MULTIARCH) NO_PKG_CONFIG=1

override_dh_auto_install:
	dh_auto_install -- LIBSUBDIR=lib/$(DEB_HOST_MULTIARCH) NO_PKG_CONFIG=1

## libbpf 0.3

=== debian/changelog ===
libbpf (0.3-2~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 17 Jan 2021 00:53:10 +0000

libbpf (0.3-2) unstable; urgency=medium

  [ Luca Boccassi ]
  * Add build-dependency on zlib1g-dev
  * Use pkg-config to get build flags
  * Enable verbose builds unless 'terse' DEB_BUILD_OPTIONS is set
  * Have libbpf-dev depend on libelf-dev and zlib1g-dev

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 10 Jan 2021 17:43:30 +0000

libbpf (0.3-1) unstable; urgency=medium

  * New upstream version 0.3 (Closes: #979166)
    - Update symbols file.
  * Update Standards-Version to 4.5.1

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 03 Jan 2021 23:27:11 +0000

libbpf (0.2-1~bpo10+1) buster-backports; urgency=medium

  * Rebuild for buster-backports. (Closes: #974975)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 20 Nov 2020 12:10:44 +0000

libbpf (0.2-1) unstable; urgency=medium

  * New upstream version 0.2
    - Update symbols file.
    - Update copyright for removed file.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 29 Oct 2020 23:07:35 +0000

libbpf (0.1.1-1) unstable; urgency=medium

  * Update from upstream v0.1.1

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 26 Sep 2020 23:17:58 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: libbpf
 Priority: optional
 Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
-Build-Depends: debhelper-compat (= 13), libelf-dev
-Standards-Version: 4.5.0
+Build-Depends: debhelper-compat (= 12), libelf-dev, zlib1g-dev, pkg-config
+Standards-Version: 4.5.1
 Section: libs
 Vcs-Browser: https://github.com/sudipm-mukherjee/libbpf
 Vcs-Git: https://github.com/sudipm-mukherjee/libbpf.git
@@ -11,7 +11,7 @@
 Section: libdevel
 Architecture: linux-any
 Multi-Arch: same
-Depends: ${misc:Depends}, libbpf0 (= ${binary:Version})
+Depends: ${misc:Depends}, libbpf0 (= ${binary:Version}), libelf-dev, zlib1g-dev
 Description: eBPF helper library (development files)
  libbpf is a library for loading eBPF programs and reading and
  manipulating eBPF objects from user-space.

## libbpf 0.4.0

=== debian/changelog ===
libbpf (0.4.0-1ubuntu1~cloud0) focal-xena; urgency=medium

  * New upstream release for the Ubuntu Cloud Archive.

 -- Openstack Ubuntu Testing Bot <openstack-testing-bot@ubuntu.com>  Wed, 16 Jun 2021 09:41:27 +0000

libbpf (0.4.0-1ubuntu1) impish; urgency=medium

  * Merge from Debian experimental, remaining changes:
    - Disable lto for now, not yet ready upstream.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 16 Jun 2021 09:28:30 +0100

libbpf (0.4.0-1) experimental; urgency=medium

  * New upstream version 0.4.0
    - Update symbols.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 25 May 2021 22:05:09 +0100

libbpf (0.3-2ubuntu1) hirsute; urgency=medium

  * Disable lto for now, not yet ready upstream.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 30 Mar 2021 17:28:01 +0200

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
export DEB_CFLAGS_MAINT_APPEND  = -Werror=implicit-function-declaration
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk

ifeq (,$(findstring terse,$(DEB_BUILD_OPTIONS)))
        VERBOSE=1
endif

%:
	dh $@ --sourcedirectory=src

override_dh_gencontrol:
	dh_gencontrol -- -v1:$(DEB_VERSION)

override_dh_makeshlibs:
	dh_makeshlibs -- -v1:$(DEB_VERSION)

override_dh_auto_build:
	dh_auto_build -- LIBSUBDIR=lib/$(DEB_HOST_MULTIARCH) V=$(VERBOSE)

override_dh_auto_install:
	dh_auto_install -- LIBSUBDIR=lib/$(DEB_HOST_MULTIARCH) V=$(VERBOSE)

## libbpf 0.5.0

=== src/Makefile ===
--- 
+++ 
@@ -36,7 +36,8 @@
 STATIC_OBJDIR := $(OBJDIR)/staticobjs
 OBJS := bpf.o btf.o libbpf.o libbpf_errno.o netlink.o \
 	nlattr.o str_error.o libbpf_probes.o bpf_prog_linfo.o xsk.o \
-	btf_dump.o hashmap.o ringbuf.o
+	btf_dump.o hashmap.o ringbuf.o strset.o linker.o gen_loader.o \
+	relo_core.o
 SHARED_OBJS := $(addprefix $(SHARED_OBJDIR)/,$(OBJS))
 STATIC_OBJS := $(addprefix $(STATIC_OBJDIR)/,$(OBJS))
 
@@ -48,9 +49,9 @@
 	VERSION_SCRIPT := libbpf.map
 endif
 
-HEADERS := bpf.h libbpf.h btf.h xsk.h libbpf_util.h \
+HEADERS := bpf.h libbpf.h btf.h libbpf_common.h libbpf_legacy.h xsk.h \
 	   bpf_helpers.h bpf_helper_defs.h bpf_tracing.h \
-	   bpf_endian.h bpf_core_read.h libbpf_common.h
+	   bpf_endian.h bpf_core_read.h skel_internal.h
 UAPI_HEADERS := $(addprefix $(TOPDIR)/include/uapi/linux/,\
 			    bpf.h bpf_common.h btf.h)
 
@@ -60,7 +61,7 @@
 
 DESTDIR ?=
 
-ifeq ($(shell uname -m),x86_64)
+ifeq ($(filter-out %64 %64be %64eb %64le %64el s390x, $(shell uname -m)),)
 	LIBSUBDIR := lib64
 else
 	LIBSUBDIR := lib
@@ -121,7 +122,7 @@
 	$(Q)if [ ! -d '$(DESTDIR)$2' ]; then		\
 		$(INSTALL) -d -m 755 '$(DESTDIR)$2';	\
 	fi;
-	$(Q)$(INSTALL) $1 $(if $3,-m $3,) '$(DESTDIR)$2'
+	$(Q)$(INSTALL) $(if $3,-m $3,) $1 '$(DESTDIR)$2'
 endef
 
 # Preserve symlinks at installation.
@@ -130,7 +131,7 @@
 	$(Q)if [ ! -d '$(DESTDIR)$2' ]; then		\
 		$(INSTALL) -d -m 755 '$(DESTDIR)$2';	\
 	fi;
-	$(Q)cp -fpR $1 '$(DESTDIR)$2'
+	$(Q)cp -fR $1 '$(DESTDIR)$2'
 endef
 
 install: all install_headers install_pkgconfig

=== debian/changelog ===
libbpf (0.5.0-1~ubuntu20.04.1) focal; urgency=medium

  * Backport to focal (LP: #1987037)

 -- Ethan Hsieh <ethan.hsieh@canonical.com>  Fri, 19 Aug 2022 13:48:35 +0800

libbpf (0.5.0-1) unstable; urgency=medium

  * New upstream version 0.5.0
    - Update copyright.
    - Update symbols.
  * Update Standards-Version to 4.6.0.1

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 17 Sep 2021 22:32:53 +0100

libbpf (0.4.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 17 Aug 2021 22:12:29 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: libbpf
 Priority: optional
-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends: debhelper-compat (= 12), libelf-dev, zlib1g-dev, pkg-config
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0.1
 Section: libs
 Vcs-Browser: https://github.com/sudipm-mukherjee/libbpf
 Vcs-Git: https://github.com/sudipm-mukherjee/libbpf.git

## libbpf 0.7.0

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: libbpf
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
-Build-Depends: debhelper-compat (= 12), libelf-dev, zlib1g-dev, pkg-config
+Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
+Build-Depends: debhelper-compat (= 13), libelf-dev, zlib1g-dev, pkg-config
 Standards-Version: 4.6.0.1
 Section: libs
 Vcs-Browser: https://github.com/sudipm-mukherjee/libbpf
@@ -22,7 +21,7 @@
 Package: libbpf0
 Architecture: linux-any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, linux-libc-dev (>= 5.14)
 Description: eBPF helper library (shared library)
  libbpf is a library for loading eBPF programs and reading and
  manipulating eBPF objects from user-space.

## libbpf 0.8.0

=== debian/changelog ===
libbpf (0.8.0-1ubuntu22.10.1) kinetic-security; urgency=medium

  * SECURITY UPDATE: heap overflow vulnerability
    - debian/patches/CVE-2021-45940_45941.patch: Use elf_getshdrnum()
      instead of e_shnum
    - CVE-2021-45940
    - CVE-2021-45941
  * SECURITY UPDATE: memory leak due to argument reg_name
    - debian/patches/CVE-2022-3533.patch: Fix memory leak in
      parse_usdt_arg()
    - CVE-2022-3533
  * SECURITY UPDATE: use-after-free vulnerability
    - debian/patches/CVE-2022-3534.patch: Fix use-after-free in
      btf_dump_name_dups
    - CVE-2022-3534
  * SECURITY UPDATE: null pointer dereference vulnerability
    - debian/patches/CVE-2022-3606.patch: Fix null-pointer dereference in
      find_prog_by_sec_insn()
    - CVE-2022-3606

 -- Nishit Majithia <nishit.majithia@canonical.com>  Thu, 01 Dec 2022 15:24:36 +0530

libbpf (0.8.0-1) unstable; urgency=medium

  * New upstream version 0.8.0
    - Update symbols.
    - Update copyright.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 05 Jun 2022 16:27:21 +0100

libbpf (0.7.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 26 Feb 2022 23:32:44 +0000

libbpf (0.7.0-1) experimental; urgency=medium

  * New upstream version 0.7.0
   - Update symbols.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 18 Feb 2022 17:31:20 +0000

libbpf (0.6.1-1) experimental; urgency=medium

  * New upstream version 0.6.1

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 21 Dec 2021 18:03:42 +0000

libbpf (0.6.0-1) experimental; urgency=medium

  * New upstream version 0.6.0
    - Update symbols.
    - Update copyright.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 04 Dec 2021 23:42:33 +0000

## libbpf 1.1.0

=== debian/changelog ===
libbpf (1.1.0-1~cloud0) jammy-antelope; urgency=medium

  * New upstream release for the Ubuntu Cloud Archive.

 -- Openstack Ubuntu Testing Bot <openstack-testing-bot@ubuntu.com>  Fri, 17 Mar 2023 10:37:53 +0000

libbpf (1.1.0-1) unstable; urgency=medium

  * New upstream version 1.1.0
    - Update symbols.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 06 Jan 2023 20:31:46 +0000

libbpf (1.0.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 06 Nov 2022 00:00:07 +0000

libbpf (1.0.1-1) experimental; urgency=medium

  * New upstream version 1.0.1

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 15 Oct 2022 23:57:54 +0100

libbpf (1.0.0-1) experimental; urgency=medium

  * New upstream version 1.0.0
    - Update SONAME and symbols.
  * Update Standards-Version to 4.6.1.0

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 26 Aug 2022 11:26:39 +0100

## libbpf 1.1.2

=== src/Makefile ===
--- 
+++ 
@@ -5,13 +5,27 @@
 	msg =
 else
 	Q = @
-	msg = @printf '  %-8s %s%s\n' "$(1)" "$(notdir $(2))" "$(if $(3), $(3))";
+	msg = @printf '  %-8s %s%s\n' "$(1)" "$(2)" "$(if $(3), $(3))";
 endif
 
-LIBBPF_VERSION := $(shell \
-	grep -oE '^LIBBPF_([0-9.]+)' libbpf.map | \
-	sort -rV | head -n1 | cut -d'_' -f2)
-LIBBPF_MAJOR_VERSION := $(firstword $(subst ., ,$(LIBBPF_VERSION)))
+LIBBPF_MAJOR_VERSION := 1
+LIBBPF_MINOR_VERSION := 1
+LIBBPF_PATCH_VERSION := 2
+LIBBPF_VERSION := $(LIBBPF_MAJOR_VERSION).$(LIBBPF_MINOR_VERSION).$(LIBBPF_PATCH_VERSION)
+LIBBPF_MAJMIN_VERSION := $(LIBBPF_MAJOR_VERSION).$(LIBBPF_MINOR_VERSION).0
+LIBBPF_MAP_VERSION := $(shell grep -oE '^LIBBPF_([0-9.]+)' libbpf.map | sort -rV | head -n1 | cut -d'_' -f2)
+ifneq ($(LIBBPF_MAJMIN_VERSION), $(LIBBPF_MAP_VERSION))
+$(error Libbpf release ($(LIBBPF_VERSION)) and map ($(LIBBPF_MAP_VERSION)) versions are out of sync!)
+endif
+
+define allow-override
+  $(if $(or $(findstring environment,$(origin $(1))),\
+            $(findstring command line,$(origin $(1)))),,\
+    $(eval $(1) = $(2)))
+endef
+
+$(call allow-override,CC,$(CROSS_COMPILE)cc)
+$(call allow-override,LD,$(CROSS_COMPILE)ld)
 
 TOPDIR = ..
 
@@ -20,9 +34,10 @@
 
 SHARED_CFLAGS += -fPIC -fvisibility=hidden -DSHARED
 
-CFLAGS ?= -g -O2 -Werror -Wall
-ALL_CFLAGS += $(CFLAGS) -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64
-ALL_LDFLAGS += $(LDFLAGS)
+CFLAGS ?= -g -O2 -Werror -Wall -std=gnu89
+ALL_CFLAGS += $(CFLAGS) -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 $(EXTRA_CFLAGS)
+ALL_LDFLAGS += $(LDFLAGS) $(EXTRA_LDFLAGS)
+
 ifdef NO_PKG_CONFIG
 	ALL_LDFLAGS += -lelf -lz
 else
@@ -35,9 +50,9 @@
 SHARED_OBJDIR := $(OBJDIR)/sharedobjs
 STATIC_OBJDIR := $(OBJDIR)/staticobjs
 OBJS := bpf.o btf.o libbpf.o libbpf_errno.o netlink.o \
-	nlattr.o str_error.o libbpf_probes.o bpf_prog_linfo.o xsk.o \
+	nlattr.o str_error.o libbpf_probes.o bpf_prog_linfo.o \
 	btf_dump.o hashmap.o ringbuf.o strset.o linker.o gen_loader.o \
-	relo_core.o
+	relo_core.o usdt.o
 SHARED_OBJS := $(addprefix $(SHARED_OBJDIR)/,$(OBJS))
 STATIC_OBJS := $(addprefix $(STATIC_OBJDIR)/,$(OBJS))
 
@@ -49,9 +64,10 @@
 	VERSION_SCRIPT := libbpf.map
 endif
 
-HEADERS := bpf.h libbpf.h btf.h libbpf_common.h libbpf_legacy.h xsk.h \
+HEADERS := bpf.h libbpf.h btf.h libbpf_common.h libbpf_legacy.h \
 	   bpf_helpers.h bpf_helper_defs.h bpf_tracing.h \
-	   bpf_endian.h bpf_core_read.h skel_internal.h
+	   bpf_endian.h bpf_core_read.h skel_internal.h libbpf_version.h \
+	   usdt.bpf.h
 UAPI_HEADERS := $(addprefix $(TOPDIR)/include/uapi/linux/,\
 			    bpf.h bpf_common.h btf.h)
 
@@ -61,7 +77,8 @@
 
 DESTDIR ?=
 
-ifeq ($(filter-out %64 %64be %64eb %64le %64el s390x, $(shell uname -m)),)
+HOSTARCH = $(firstword $(subst -, ,$(shell $(CC) -dumpmachine)))
+ifeq ($(filter-out %64 %64be %64eb %64le %64el s390x, $(HOSTARCH)),)
 	LIBSUBDIR := lib64
 else
 	LIBSUBDIR := lib
@@ -99,7 +116,7 @@
 		  -Wl,-soname,libbpf.so.$(LIBBPF_MAJOR_VERSION) \
 		  $^ $(ALL_LDFLAGS) -o $@
 
-$(OBJDIR)/libbpf.pc:
+$(OBJDIR)/libbpf.pc: force
 	$(Q)sed -e "s|@PREFIX@|$(PREFIX)|" \
 		-e "s|@LIBDIR@|$(LIBDIR_PC)|" \
 		-e "s|@VERSION@|$(LIBBPF_VERSION)|" \
@@ -152,7 +169,7 @@
 	$(call msg,CLEAN)
 	$(Q)rm -rf *.o *.a *.so *.so.* *.pc $(SHARED_OBJDIR) $(STATIC_OBJDIR)
 
-.PHONY: cscope tags
+.PHONY: cscope tags force
 cscope:
 	$(call msg,CSCOPE)
 	$(Q)ls *.c *.h > cscope.files
@@ -162,3 +179,5 @@
 	$(call msg,CTAGS)
 	$(Q)rm -f TAGS tags
 	$(Q)ls *.c *.h | xargs $(TAGS_PROG) -a
+
+force:

=== debian/changelog ===
libbpf (1.1.2-0+deb12u1) bookworm; urgency=medium

  * New upstream version 1.1.2 (Closes: #1101745)
    - Upstream changes:
      - libbpf: fix BPF skeleton forward/backward compat handling.
      - libbpf: Fix bpf_object__open_skeleton()'s mishandling of options.
      - libbpf: Ensure new BTF objects inherit input endianness.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 12 May 2025 19:29:05 +0100

=== debian/control ===
Source: libbpf
Priority: optional
Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
Build-Depends: debhelper-compat (= 13), libelf-dev, zlib1g-dev, pkg-config
Standards-Version: 4.6.1.0
Section: libs
Vcs-Browser: https://github.com/sudipm-mukherjee/libbpf
Vcs-Git: https://github.com/sudipm-mukherjee/libbpf.git

Package: libbpf-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends: ${misc:Depends}, libbpf1 (= ${binary:Version}), libelf-dev, zlib1g-dev
Description: eBPF helper library (development files)
 libbpf is a library for loading eBPF programs and reading and
 manipulating eBPF objects from user-space.
 .
 This package is needed to compile programs against libbpf.

Package: libbpf1
Architecture: linux-any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: eBPF helper library (shared library)
 libbpf is a library for loading eBPF programs and reading and
 manipulating eBPF objects from user-space.
 .
 This package contains the shared library.

## libbpf 1.2.0

=== debian/changelog ===
libbpf (1.2.0-1) experimental; urgency=medium

  * New upstream version 1.2.0
    - Update copyright.
    - Update symbols.
  * Update Standards-Version to 4.6.2

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 09 Jul 2023 00:58:34 +0100

## libbpf 1.2.2

=== debian/changelog ===
libbpf (1.2.2-2~cloud0) jammy-bobcat; urgency=medium

  * New upstream release for the Ubuntu Cloud Archive.

 -- Openstack Ubuntu Testing Bot <openstack-testing-bot@ubuntu.com>  Sat, 05 Aug 2023 00:12:29 +0000

libbpf (1.2.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 04 Aug 2023 19:46:30 +0100

libbpf (1.2.2-1) experimental; urgency=medium

  * New upstream version 1.2.2

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 02 Aug 2023 19:27:56 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends: debhelper-compat (= 13), libelf-dev, zlib1g-dev, pkg-config
-Standards-Version: 4.6.1.0
+Standards-Version: 4.6.2
 Section: libs
 Vcs-Browser: https://github.com/sudipm-mukherjee/libbpf
 Vcs-Git: https://github.com/sudipm-mukherjee/libbpf.git

## libbpf 1.3.0

=== src/Makefile ===
--- 
+++ 
@@ -9,8 +9,8 @@
 endif
 
 LIBBPF_MAJOR_VERSION := 1
-LIBBPF_MINOR_VERSION := 1
-LIBBPF_PATCH_VERSION := 2
+LIBBPF_MINOR_VERSION := 3
+LIBBPF_PATCH_VERSION := 0
 LIBBPF_VERSION := $(LIBBPF_MAJOR_VERSION).$(LIBBPF_MINOR_VERSION).$(LIBBPF_PATCH_VERSION)
 LIBBPF_MAJMIN_VERSION := $(LIBBPF_MAJOR_VERSION).$(LIBBPF_MINOR_VERSION).0
 LIBBPF_MAP_VERSION := $(shell grep -oE '^LIBBPF_([0-9.]+)' libbpf.map | sort -rV | head -n1 | cut -d'_' -f2)
@@ -35,7 +35,10 @@
 SHARED_CFLAGS += -fPIC -fvisibility=hidden -DSHARED
 
 CFLAGS ?= -g -O2 -Werror -Wall -std=gnu89
-ALL_CFLAGS += $(CFLAGS) -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 $(EXTRA_CFLAGS)
+ALL_CFLAGS += $(CFLAGS) 						\
+	      -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64		\
+	      -Wno-unknown-warning-option -Wno-format-overflow		\
+	      $(EXTRA_CFLAGS)
 ALL_LDFLAGS += $(LDFLAGS) $(EXTRA_LDFLAGS)
 
 ifdef NO_PKG_CONFIG
@@ -52,7 +55,7 @@
 OBJS := bpf.o btf.o libbpf.o libbpf_errno.o netlink.o \
 	nlattr.o str_error.o libbpf_probes.o bpf_prog_linfo.o \
 	btf_dump.o hashmap.o ringbuf.o strset.o linker.o gen_loader.o \
-	relo_core.o usdt.o
+	relo_core.o usdt.o zip.o elf.o
 SHARED_OBJS := $(addprefix $(SHARED_OBJDIR)/,$(OBJS))
 STATIC_OBJS := $(addprefix $(STATIC_OBJDIR)/,$(OBJS))

=== docs/sphinx/Makefile ===
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = ../src
BUILDDIR      = build

help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)"

%:
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)"

=== debian/changelog ===
libbpf (1.3.0-2build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 07:44:47 +0000

libbpf (1.3.0-2build1) noble; urgency=medium

  * No-change rebuild against libelf1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 01 Mar 2024 00:59:32 +0000

libbpf (1.3.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 03 Dec 2023 22:03:49 +0000

libbpf (1.3.0-1) experimental; urgency=medium

  * New upstream version 1.3.0
    - Update symbols.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 30 Nov 2023 15:36:58 +0000

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
 Source: libbpf
 Priority: optional
-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends: debhelper-compat (= 13), libelf-dev, zlib1g-dev, pkg-config
 Standards-Version: 4.6.2
 Section: libs

## libbpf 1.4.1

=== src/Makefile ===
--- 
+++ 
@@ -9,8 +9,8 @@
 endif
 
 LIBBPF_MAJOR_VERSION := 1
-LIBBPF_MINOR_VERSION := 3
-LIBBPF_PATCH_VERSION := 0
+LIBBPF_MINOR_VERSION := 4
+LIBBPF_PATCH_VERSION := 1
 LIBBPF_VERSION := $(LIBBPF_MAJOR_VERSION).$(LIBBPF_MINOR_VERSION).$(LIBBPF_PATCH_VERSION)
 LIBBPF_MAJMIN_VERSION := $(LIBBPF_MAJOR_VERSION).$(LIBBPF_MINOR_VERSION).0
 LIBBPF_MAP_VERSION := $(shell grep -oE '^LIBBPF_([0-9.]+)' libbpf.map | sort -rV | head -n1 | cut -d'_' -f2)
@@ -55,7 +55,7 @@
 OBJS := bpf.o btf.o libbpf.o libbpf_errno.o netlink.o \
 	nlattr.o str_error.o libbpf_probes.o bpf_prog_linfo.o \
 	btf_dump.o hashmap.o ringbuf.o strset.o linker.o gen_loader.o \
-	relo_core.o usdt.o zip.o elf.o
+	relo_core.o usdt.o zip.o elf.o features.o
 SHARED_OBJS := $(addprefix $(SHARED_OBJDIR)/,$(OBJS))
 STATIC_OBJS := $(addprefix $(STATIC_OBJDIR)/,$(OBJS))

=== debian/changelog ===
libbpf (1.4.1-1) unstable; urgency=medium

  * New upstream version 1.4.1 (Closes: #1070114)
    - Add new symbols.
  * Update copyright.
  * Remove missing comments from symbols file.
  * Use pkgconf instead of pkg-config.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 11 May 2024 17:52:58 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: libbpf
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
-Build-Depends: debhelper-compat (= 13), libelf-dev, zlib1g-dev, pkg-config
+Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
+Build-Depends: debhelper-compat (= 13), libelf-dev, zlib1g-dev, pkgconf
 Standards-Version: 4.6.2
 Section: libs
 Vcs-Browser: https://github.com/sudipm-mukherjee/libbpf

## libbpf 1.4.3

=== src/Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 
 LIBBPF_MAJOR_VERSION := 1
 LIBBPF_MINOR_VERSION := 4
-LIBBPF_PATCH_VERSION := 1
+LIBBPF_PATCH_VERSION := 3
 LIBBPF_VERSION := $(LIBBPF_MAJOR_VERSION).$(LIBBPF_MINOR_VERSION).$(LIBBPF_PATCH_VERSION)
 LIBBPF_MAJMIN_VERSION := $(LIBBPF_MAJOR_VERSION).$(LIBBPF_MINOR_VERSION).0
 LIBBPF_MAP_VERSION := $(shell grep -oE '^LIBBPF_([0-9.]+)' libbpf.map | sort -rV | head -n1 | cut -d'_' -f2)

=== debian/changelog ===
libbpf (1.4.3-1) unstable; urgency=medium

  * New upstream version 1.4.3
  * Move Vcs to salsa.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 16 Jun 2024 12:07:08 +0100

libbpf (1.4.2-1) unstable; urgency=medium

  * New upstream version 1.4.2

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 25 May 2024 14:38:32 +0100

## libbpf 1.4.5

=== src/Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 
 LIBBPF_MAJOR_VERSION := 1
 LIBBPF_MINOR_VERSION := 4
-LIBBPF_PATCH_VERSION := 3
+LIBBPF_PATCH_VERSION := 5
 LIBBPF_VERSION := $(LIBBPF_MAJOR_VERSION).$(LIBBPF_MINOR_VERSION).$(LIBBPF_PATCH_VERSION)
 LIBBPF_MAJMIN_VERSION := $(LIBBPF_MAJOR_VERSION).$(LIBBPF_MINOR_VERSION).0
 LIBBPF_MAP_VERSION := $(shell grep -oE '^LIBBPF_([0-9.]+)' libbpf.map | sort -rV | head -n1 | cut -d'_' -f2)

=== debian/changelog ===
libbpf (1.4.5-1) unstable; urgency=medium

  * New upstream version 1.4.5

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Wed, 17 Jul 2024 21:40:07 +0100

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Build-Depends: debhelper-compat (= 13), libelf-dev, zlib1g-dev, pkgconf
 Standards-Version: 4.6.2
 Section: libs
-Vcs-Browser: https://github.com/sudipm-mukherjee/libbpf
-Vcs-Git: https://github.com/sudipm-mukherjee/libbpf.git
+Vcs-Browser: https://salsa.debian.org/sudip/libbpf
+Vcs-Git: https://salsa.debian.org/sudip/libbpf.git
 
 Package: libbpf-dev
 Section: libdevel

## libbpf 1.4.6

=== src/Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 
 LIBBPF_MAJOR_VERSION := 1
 LIBBPF_MINOR_VERSION := 4
-LIBBPF_PATCH_VERSION := 5
+LIBBPF_PATCH_VERSION := 6
 LIBBPF_VERSION := $(LIBBPF_MAJOR_VERSION).$(LIBBPF_MINOR_VERSION).$(LIBBPF_PATCH_VERSION)
 LIBBPF_MAJMIN_VERSION := $(LIBBPF_MAJOR_VERSION).$(LIBBPF_MINOR_VERSION).0
 LIBBPF_MAP_VERSION := $(shell grep -oE '^LIBBPF_([0-9.]+)' libbpf.map | sort -rV | head -n1 | cut -d'_' -f2)

=== debian/changelog ===
libbpf (1.4.6-1~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 14 Nov 2024 21:57:05 +0000

libbpf (1.4.6-1) unstable; urgency=medium

  * New upstream version 1.4.6
  * Update Standards-Version to 4.7.0

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 12 Sep 2024 21:39:55 +0100

## libbpf 1.5.0

=== debian/changelog ===
libbpf (1.5.0-3) unstable; urgency=medium

  * CVE-2025-29481:
    - Fix buffer overflow in bpf_object__init_prog. (Closes: #1102672)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 25 Apr 2025 19:49:15 +0100

libbpf (1.5.0-2) unstable; urgency=medium

  * Add basic autopkgtest.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 26 Nov 2024 07:21:01 +0000

libbpf (1.5.0-1) unstable; urgency=medium

  * New upstream version 1.5.0
    - Update copyright.
    - Update symbols.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 09 Nov 2024 21:28:32 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends: debhelper-compat (= 13), libelf-dev, zlib1g-dev, pkgconf
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Section: libs
 Vcs-Browser: https://salsa.debian.org/sudip/libbpf
 Vcs-Git: https://salsa.debian.org/sudip/libbpf.git

## libbpf 1.6.1

=== debian/changelog ===
libbpf (1.6.1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sat, 16 Aug 2025 22:53:11 +0100

libbpf (1.6.1-1~exp1) experimental; urgency=medium

  * New upstream version 1.6.1
    - Update symbols.
    - Remove upstream applied patch.
  * Remove old fsf address in d/copyright.
  * Update Standards-Version to 4.7.2.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Sun, 10 Aug 2025 10:29:02 +0100

## libbpf 1.6.2

=== src/Makefile ===
--- 
+++ 
@@ -9,8 +9,8 @@
 endif
 
 LIBBPF_MAJOR_VERSION := 1
-LIBBPF_MINOR_VERSION := 4
-LIBBPF_PATCH_VERSION := 6
+LIBBPF_MINOR_VERSION := 6
+LIBBPF_PATCH_VERSION := 2
 LIBBPF_VERSION := $(LIBBPF_MAJOR_VERSION).$(LIBBPF_MINOR_VERSION).$(LIBBPF_PATCH_VERSION)
 LIBBPF_MAJMIN_VERSION := $(LIBBPF_MAJOR_VERSION).$(LIBBPF_MINOR_VERSION).0
 LIBBPF_MAP_VERSION := $(shell grep -oE '^LIBBPF_([0-9.]+)' libbpf.map | sort -rV | head -n1 | cut -d'_' -f2)
@@ -26,6 +26,7 @@
 
 $(call allow-override,CC,$(CROSS_COMPILE)cc)
 $(call allow-override,LD,$(CROSS_COMPILE)ld)
+PKG_CONFIG ?= pkg-config
 
 TOPDIR = ..
 
@@ -41,10 +42,12 @@
 	      $(EXTRA_CFLAGS)
 ALL_LDFLAGS += $(LDFLAGS) $(EXTRA_LDFLAGS)
 
+ifeq ($(shell command -v $(PKG_CONFIG) 2> /dev/null),)
+NO_PKG_CONFIG := 1
+endif
 ifdef NO_PKG_CONFIG
 	ALL_LDFLAGS += -lelf -lz
 else
-	PKG_CONFIG ?= pkg-config
 	ALL_CFLAGS += $(shell $(PKG_CONFIG) --cflags libelf zlib)
 	ALL_LDFLAGS += $(shell $(PKG_CONFIG) --libs libelf zlib)
 endif
@@ -55,7 +58,7 @@
 OBJS := bpf.o btf.o libbpf.o libbpf_errno.o netlink.o \
 	nlattr.o str_error.o libbpf_probes.o bpf_prog_linfo.o \
 	btf_dump.o hashmap.o ringbuf.o strset.o linker.o gen_loader.o \
-	relo_core.o usdt.o zip.o elf.o features.o
+	relo_core.o usdt.o zip.o elf.o features.o btf_iter.o btf_relocate.o
 SHARED_OBJS := $(addprefix $(SHARED_OBJDIR)/,$(OBJS))
 STATIC_OBJS := $(addprefix $(STATIC_OBJDIR)/,$(OBJS))
 
@@ -119,13 +122,13 @@
 		  -Wl,-soname,libbpf.so.$(LIBBPF_MAJOR_VERSION) \
 		  $^ $(ALL_LDFLAGS) -o $@
 
-$(OBJDIR)/libbpf.pc: force
+$(OBJDIR)/libbpf.pc: force | $(OBJDIR)
 	$(Q)sed -e "s|@PREFIX@|$(PREFIX)|" \
 		-e "s|@LIBDIR@|$(LIBDIR_PC)|" \
 		-e "s|@VERSION@|$(LIBBPF_VERSION)|" \
 		< libbpf.pc.template > $@
 
-$(STATIC_OBJDIR) $(SHARED_OBJDIR):
+$(OBJDIR) $(STATIC_OBJDIR) $(SHARED_OBJDIR):
 	$(call msg,MKDIR,$@)
 	$(Q)mkdir -p $@

=== debian/changelog ===
libbpf (1.6.2-1) unstable; urgency=medium

  * New upstream version 1.6.2
    - Update symbols.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 22 Aug 2025 12:43:08 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends: debhelper-compat (= 13), libelf-dev, zlib1g-dev, pkgconf
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Section: libs
 Vcs-Browser: https://salsa.debian.org/sudip/libbpf
 Vcs-Git: https://salsa.debian.org/sudip/libbpf.git

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_CFLAGS_MAINT_APPEND  = -Werror=implicit-function-declaration
 include /usr/share/dpkg/pkg-info.mk
 include /usr/share/dpkg/architecture.mk

=== debian/tests/control ===
Tests: runtest.sh
Depends: @, gcc
Restrictions: superficial

## libbpf 1.6.3

=== src/Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 
 LIBBPF_MAJOR_VERSION := 1
 LIBBPF_MINOR_VERSION := 6
-LIBBPF_PATCH_VERSION := 2
+LIBBPF_PATCH_VERSION := 3
 LIBBPF_VERSION := $(LIBBPF_MAJOR_VERSION).$(LIBBPF_MINOR_VERSION).$(LIBBPF_PATCH_VERSION)
 LIBBPF_MAJMIN_VERSION := $(LIBBPF_MAJOR_VERSION).$(LIBBPF_MINOR_VERSION).0
 LIBBPF_MAP_VERSION := $(shell grep -oE '^LIBBPF_([0-9.]+)' libbpf.map | sort -rV | head -n1 | cut -d'_' -f2)
@@ -38,7 +38,7 @@
 CFLAGS ?= -g -O2 -Werror -Wall -std=gnu89
 ALL_CFLAGS += $(CFLAGS) 						\
 	      -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64		\
-	      -Wno-unknown-warning-option -Wno-format-overflow		\
+	      -Wno-format-overflow					\
 	      $(EXTRA_CFLAGS)
 ALL_LDFLAGS += $(LDFLAGS) $(EXTRA_LDFLAGS)

=== debian/changelog ===
libbpf (1.6.3-1~exp1) experimental; urgency=medium

  * New upstream version 1.6.3
  * Update Standards-Version to 4.7.3

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 23 Feb 2026 20:05:40 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
 Build-Depends: debhelper-compat (= 13), libelf-dev, zlib1g-dev, pkgconf
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Section: libs
 Vcs-Browser: https://salsa.debian.org/sudip/libbpf
 Vcs-Git: https://salsa.debian.org/sudip/libbpf.git
